Global $oErrorHandler = ObjEvent("AutoIt.Error", "_SkipObjectError")
Func _SkipObjectError()
	; Do nothing special, just check @error after suspect functions.
EndFunc   ;==>_SkipObjectError


Func _ArrayToString($aArray, $sDelim_Col = "|")
	If Not IsArray($aArray) Then Return $aArray
	If $sDelim_Col = Default Then $sDelim_Col = "|"
	Local $sRet = "", $x = 0, $y = UBound($aArray) - 1
	If $y < 0 Then Return $aArray
	If $aArray[0] = $y Then $x = 1
	For $i = $x To $y
		$sRet &= $aArray[$i] & $sDelim_Col
	Next
	Return StringTrimRight($sRet, StringLen($sDelim_Col))
EndFunc   ;==>_ArrayToString

ConsoleWrite(@CRLF & @CRLF)
Local $objWMG = ObjGet("winmgmts:\\.\root\cimv2")
;~ Local $objWQL = $objWMG.ExecQuery("SELECT * FROM Win32_NetworkAdapter WHERE NetConnectionID<>NULL", "WQL", 0x30)
Local $objWQL = $objWMG.ExecQuery("SELECT * FROM Win32_NetworkAdapter WHERE NetConnectionID != NULL", "WQL", 0x30)
;~ Local $objWQL = $objWMG.ExecQuery("SELECT * FROM Win32_NetworkAdapter", "WQL", 0x30)
Local $i = 0, $x = 0
For $objVAR In $objWQL
	$i += 1
	ConsoleWrite("+-----------------------------------" & @CRLF)
	ConsoleWrite("!Win32_NetworkAdapter instance: " & $i & @CRLF)
	ConsoleWrite("+-----------------------------------" & @CRLF)
	ConsoleWrite("-AdapterType                : " & @TAB & $objVAR.AdapterType & @CRLF)
	ConsoleWrite("-AdapterTypeID              : " & @TAB & $objVAR.AdapterTypeID & @CRLF)
	ConsoleWrite("-AutoSense                  : " & @TAB & $objVAR.AutoSense & @CRLF)
	ConsoleWrite("-Availability               : " & @TAB & $objVAR.Availability & @CRLF)
	ConsoleWrite("-Caption                    : " & @TAB & $objVAR.Caption & @CRLF)
	ConsoleWrite("-ConfigManagerErrorCode     : " & @TAB & $objVAR.ConfigManagerErrorCode & @CRLF)
	ConsoleWrite("-ConfigManagerUserConfig    : " & @TAB & $objVAR.ConfigManagerUserConfig & @CRLF)
	ConsoleWrite("-CreationClassName          : " & @TAB & $objVAR.CreationClassName & @CRLF)
	ConsoleWrite("-Description                : " & @TAB & $objVAR.Description & @CRLF)
	ConsoleWrite("-DeviceID                   : " & @TAB & $objVAR.DeviceID & @CRLF)
	ConsoleWrite("-ErrorCleared               : " & @TAB & $objVAR.ErrorCleared & @CRLF)
	ConsoleWrite("-ErrorDescription           : " & @TAB & $objVAR.ErrorDescription & @CRLF)
	ConsoleWrite("-GUID                       : " & @TAB & $objVAR.GUID & @CRLF)
	Local $strIndex = $objVAR.Index
	ConsoleWrite("-Index                      : " & @TAB & $strIndex & @CRLF)
	ConsoleWrite("-InstallDate                : " & @TAB & $objVAR.InstallDate & @CRLF)
	ConsoleWrite("-Installed                  : " & @TAB & $objVAR.Installed & @CRLF)
	ConsoleWrite("-InterfaceIndex             : " & @TAB & $objVAR.InterfaceIndex & @CRLF)
	ConsoleWrite("-LastErrorCode              : " & @TAB & $objVAR.LastErrorCode & @CRLF)
	ConsoleWrite("-MACAddress                 : " & @TAB & $objVAR.MACAddress & @CRLF)
	ConsoleWrite("-Manufacturer               : " & @TAB & $objVAR.Manufacturer & @CRLF)
	ConsoleWrite("-MaxNumberControlled        : " & @TAB & $objVAR.MaxNumberControlled & @CRLF)
	ConsoleWrite("-MaxSpeed                   : " & @TAB & $objVAR.MaxSpeed & @CRLF)
	ConsoleWrite("-Name                       : " & @TAB & $objVAR.Name & @CRLF)
	ConsoleWrite("-NetConnectionID            : " & @TAB & $objVAR.NetConnectionID & @CRLF)
	ConsoleWrite("-NetConnectionStatus        : " & @TAB & $objVAR.NetConnectionStatus & @CRLF)
	ConsoleWrite("-NetEnabled                 : " & @TAB & $objVAR.NetEnabled & @CRLF)
	$strNetworkAddresses = $objVAR.NetworkAddresses()
	$strNetworkAddresses = _ArrayToString($strNetworkAddresses, ", ")
	ConsoleWrite("-NetworkAddresses           : " & @TAB & $strNetworkAddresses & @CRLF)
	ConsoleWrite("-PermanentAddress           : " & @TAB & $objVAR.PermanentAddress & @CRLF)
	ConsoleWrite("-PhysicalAdapter            : " & @TAB & $objVAR.PhysicalAdapter & @CRLF)
	ConsoleWrite("-PNPDeviceID                : " & @TAB & $objVAR.PNPDeviceID & @CRLF)
	$strPowerManagementCapabilities = $objVAR.PowerManagementCapabilities()
	$strPowerManagementCapabilities = _ArrayToString($strPowerManagementCapabilities, ", ")
	ConsoleWrite("-PowerManagementCapabilities: " & @TAB & $objVAR.PowerManagementCapabilities & @CRLF)
	ConsoleWrite("-PowerManagementSupported   : " & @TAB & $objVAR.PowerManagementSupported & @CRLF)
	ConsoleWrite("-ProductName                : " & @TAB & $objVAR.ProductName & @CRLF)
	ConsoleWrite("-ServiceName                : " & @TAB & $objVAR.ServiceName & @CRLF)
	ConsoleWrite("-Speed                      : " & @TAB & $objVAR.Speed & @CRLF) ; Vista+
	ConsoleWrite("-Status                     : " & @TAB & $objVAR.Status & @CRLF)
	ConsoleWrite("-StatusInfo                 : " & @TAB & $objVAR.StatusInfo & @CRLF)
	ConsoleWrite("-SystemCreationClassName    : " & @TAB & $objVAR.SystemCreationClassName & @CRLF)
	ConsoleWrite("-SystemName                 : " & @TAB & $objVAR.SystemName & @CRLF)
	ConsoleWrite("-TimeOfLastReset            : " & @TAB & $objVAR.TimeOfLastReset & @CRLF)
	Local $objWQL = $objWMG.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration WHERE Index=' & $strIndex, "WQL", 0x30)
;~ 	Local $objWQL = $objWMG.ExecQuery('SELECT * FROM Win32_NetworkAdapterConfiguration', "WQL", 0x30)
	For $objVARN In $objWQL
		$x += 1
		ConsoleWrite("+-----------------------------------" & @CRLF)
		ConsoleWrite("!Win32_NetworkAdapterConfiguration instance: " & $x & @CRLF)
		ConsoleWrite("+-----------------------------------" & @CRLF)
		$strDefaultIPGateway = $objVARN.DefaultIPGateway()
		$strDefaultIPGateway = _ArrayToString($strDefaultIPGateway, ", ")
		ConsoleWrite("-MACAddress                  : " & @TAB & $objVARN.MACAddress & @CRLF)
		ConsoleWrite("-Description                 : " & @TAB & $objVARN.Description & @CRLF)
		ConsoleWrite("-DHCPEnabled                 : " & @TAB & $objVARN.DHCPEnabled & @CRLF)
		$strIPAddress = $objVARN.IPAddress()
		$strIPAddress = _ArrayToString($strIPAddress, ", ")
		ConsoleWrite("-IPAddress                   : " & @TAB & $strIPAddress & @CRLF)
		$strIPSubnet = $objVARN.IPSubnet()
		$strIPSubnet = _ArrayToString($strIPSubnet, ", ")
		$strGatewayCostMetric = $objVARN.GatewayCostMetric()
		$strGatewayCostMetric = _ArrayToString($strGatewayCostMetric, ", ")
		ConsoleWrite("-IPSubnet                    : " & @TAB & $strIPSubnet & @CRLF)
		ConsoleWrite("-IPConnectionMetric          : " & @TAB & $objVARN.IPConnectionMetric & @CRLF)
		ConsoleWrite("-DHCPLeaseExpires            : " & @TAB & $objVARN.DHCPLeaseExpires & @CRLF)
		ConsoleWrite("-DHCPLeaseObtained           : " & @TAB & $objVARN.DHCPLeaseObtained & @CRLF)
		ConsoleWrite("-DHCPServer                  : " & @TAB & $objVARN.DHCPServer & @CRLF)
		ConsoleWrite("-DNSDomain                   : " & @TAB & $objVARN.DNSDomain & @CRLF)
		ConsoleWrite("-IPEnabled                   : " & @TAB & $objVARN.IPEnabled & @CRLF)
		ConsoleWrite("-DefaultIPGateway            : " & @TAB & $strDefaultIPGateway & @CRLF)
		ConsoleWrite("-GatewayCostMetric           : " & @TAB & $strGatewayCostMetric & @CRLF)
		ConsoleWrite("-IPFilterSecurityEnabled     : " & @TAB & $objVARN.IPFilterSecurityEnabled & @CRLF)
		ConsoleWrite("-IPPortSecurityEnabled       : " & @TAB & $objVARN.IPPortSecurityEnabled & @CRLF)
		$strDNSDomainSuffixSearchOrder = $objVARN.DNSDomainSuffixSearchOrder()
		$strDNSDomainSuffixSearchOrder = _ArrayToString($strDNSDomainSuffixSearchOrder, ", ")
		ConsoleWrite("-DNSDomainSuffixSearchOrder  : " & @TAB & $strDNSDomainSuffixSearchOrder & @CRLF)
		ConsoleWrite("-DNSEnabledForWINSResolution : " & @TAB & $objVARN.DNSEnabledForWINSResolution & @CRLF)
		ConsoleWrite("-DNSHostName                 : " & @TAB & $objVARN.DNSHostName & @CRLF)
		$strDNSServerSearchOrder = $objVARN.DNSServerSearchOrder()
		$strDNSServerSearchOrder = _ArrayToString($strDNSServerSearchOrder, ", ")
		ConsoleWrite("-DNSServerSearchOrder        : " & @TAB & $strDNSServerSearchOrder & @CRLF)
		ConsoleWrite("-DomainDNSRegistrationEnabled: " & @TAB & $objVARN.DomainDNSRegistrationEnabled & @CRLF)
		ConsoleWrite("-ForwardBufferMemory         : " & @TAB & $objVARN.ForwardBufferMemory & @CRLF)
		ConsoleWrite("-FullDNSRegistrationEnabled  : " & @TAB & $objVARN.FullDNSRegistrationEnabled & @CRLF)
		ConsoleWrite("-IGMPLevel                   : " & @TAB & $objVARN.IGMPLevel & @CRLF)
		ConsoleWrite("-Index                       : " & @TAB & $objVARN.Index & @CRLF)
		$strIPSecPermitIPProtocols = $objVARN.IPSecPermitIPProtocols()
		$strIPSecPermitIPProtocols = _ArrayToString($strIPSecPermitIPProtocols, ", ")
		ConsoleWrite("-IPSecPermitIPProtocols      : " & @TAB & $strIPSecPermitIPProtocols & @CRLF)
		$strIPSecPermitTCPPorts = $objVARN.IPSecPermitTCPPorts()
		$strIPSecPermitTCPPorts = _ArrayToString($strIPSecPermitTCPPorts, ", ")
		ConsoleWrite("-IPSecPermitTCPPorts         : " & @TAB & $strIPSecPermitTCPPorts & @CRLF)
		$strIPSecPermitUDPPorts = $objVARN.IPSecPermitUDPPorts()
		$strIPSecPermitUDPPorts = _ArrayToString($strIPSecPermitUDPPorts, ", ")
		ConsoleWrite("-IPSecPermitUDPPorts         : " & @TAB & $strIPSecPermitUDPPorts & @CRLF)
		ConsoleWrite("-IPUseZeroBroadcast          : " & @TAB & $objVARN.IPUseZeroBroadcast & @CRLF)
		ConsoleWrite("-IPXAddress                  : " & @TAB & $objVARN.IPXAddress & @CRLF)
		ConsoleWrite("-IPXEnabled                  : " & @TAB & $objVARN.IPXEnabled & @CRLF)
		$strIPXFrameType = $objVARN.IPXFrameType()
		$strIPXFrameType = _ArrayToString($strIPXFrameType, ", ")
		ConsoleWrite("-IPXFrameType                : " & @TAB & $strIPXFrameType & @CRLF)
		$strIPXNetworkNumber = $objVARN.IPXNetworkNumber()
		$strIPXNetworkNumber = _ArrayToString($strIPXNetworkNumber, ", ")
		ConsoleWrite("-IPXNetworkNumber            : " & @TAB & $strIPXNetworkNumber & @CRLF)
		ConsoleWrite("-IPXVirtualNetNumber         : " & @TAB & $objVARN.IPXVirtualNetNumber & @CRLF)
		ConsoleWrite("-KeepAliveInterval           : " & @TAB & $objVARN.KeepAliveInterval & @CRLF)
		ConsoleWrite("-KeepAliveTime               : " & @TAB & $objVARN.KeepAliveTime & @CRLF)
		ConsoleWrite("-MTU                         : " & @TAB & $objVARN.MTU & @CRLF)
		ConsoleWrite("-NumForwardPackets           : " & @TAB & $objVARN.NumForwardPackets & @CRLF)
		ConsoleWrite("-PMTUBHDetectEnabled         : " & @TAB & $objVARN.PMTUBHDetectEnabled & @CRLF)
		ConsoleWrite("-PMTUDiscoveryEnabled        : " & @TAB & $objVARN.PMTUDiscoveryEnabled & @CRLF)
		ConsoleWrite("-ServiceName                 : " & @TAB & $objVARN.ServiceName & @CRLF)
		ConsoleWrite("-SettingID                   : " & @TAB & $objVARN.SettingID & @CRLF)
		ConsoleWrite("-TcpipNetbiosOptions         : " & @TAB & $objVARN.TcpipNetbiosOptions & @CRLF)
		ConsoleWrite("-TcpMaxConnectRetransmissions: " & @TAB & $objVARN.TcpMaxConnectRetransmissions & @CRLF)
		ConsoleWrite("-TcpMaxDataRetransmissions   : " & @TAB & $objVARN.TcpMaxDataRetransmissions & @CRLF)
		ConsoleWrite("-TcpNumConnections           : " & @TAB & $objVARN.TcpNumConnections & @CRLF)
		ConsoleWrite("-TcpUseRFC1122UrgentPointer  : " & @TAB & $objVARN.TcpUseRFC1122UrgentPointer & @CRLF)
		ConsoleWrite("-TcpWindowSize               : " & @TAB & $objVARN.TcpWindowSize & @CRLF)
		ConsoleWrite("-WINSEnableLMHostsLookup     : " & @TAB & $objVARN.WINSEnableLMHostsLookup & @CRLF)
		ConsoleWrite("-WINSHostLookupFile          : " & @TAB & $objVARN.WINSHostLookupFile & @CRLF)
		ConsoleWrite("-WINSPrimaryServer           : " & @TAB & $objVARN.WINSPrimaryServer & @CRLF)
		ConsoleWrite("-WINSScopeID                 : " & @TAB & $objVARN.WINSScopeID & @CRLF)
		ConsoleWrite("-WINSSecondaryServer         : " & @TAB & $objVARN.WINSSecondaryServer & @CRLF)
		ConsoleWrite("-ArpAlwaysSourceRoute        : " & @TAB & $objVARN.ArpAlwaysSourceRoute & @CRLF)
		ConsoleWrite("-ArpUseEtherSNAP             : " & @TAB & $objVARN.ArpUseEtherSNAP & @CRLF)
		ConsoleWrite("-DatabasePath                : " & @TAB & $objVARN.DatabasePath & @CRLF)
		ConsoleWrite("-DeadGWDetectEnabled         : " & @TAB & $objVARN.DeadGWDetectEnabled & @CRLF)
		ConsoleWrite("-DefaultTOS                  : " & @TAB & $objVARN.DefaultTOS & @CRLF)
		ConsoleWrite("-DefaultTTL                  : " & @TAB & $objVARN.DefaultTTL & @CRLF)
	Next
Next
